upowerd leaks memory with Logitech universal receiver

Bug #757551 reported by Plouj on 2011-04-11
38
This bug affects 8 people
Affects Status Importance Assigned to Milestone
upower (Ubuntu)
Undecided
Martin Pitt
Vivid
Undecided
Martin Pitt

Bug Description

Binary package hint: upower

I currently have 36 days of uptime on my laptop (using suspend a lot) and over time, I've noticed that the upowerd process got to the top of the list in terms of memory usage by claiming 1GB+. I can manage with this situation since I have 6GB of physical memory, but I'm sure that people with less in their laptops will not be so fortunate.

ProblemType: Bug
DistroRelease: Ubuntu 10.10
Package: upower 0.9.5-4
ProcVersionSignature: Ubuntu 2.6.35-27.48-generic 2.6.35.11
Uname: Linux 2.6.35-27-generic x86_64
Architecture: amd64
Date: Mon Apr 11 09:47:23 2011
EcryptfsInUse: Yes
ExecutablePath: /usr/lib/upower/upowerd
InstallationMedia: Ubuntu 10.04.1 LTS "Lucid Lynx" - Release amd64 (20100816.1)
ProcEnviron:

SourcePackage: upower

Plouj (plouj) wrote :
Launchpad Janitor (janitor) wrote :

Status changed to 'Confirmed' because the bug affects multiple users.

Changed in upower (Ubuntu):
status: New → Confirmed
wilsonb (wilsonb) wrote :

Ubuntu 12.04 LTS
Kernel 3.2.0-23-generic-pae
Gnome 3.4.1
2 GiB of ram

I also noticed Upower using a lot of VM , it went down to 27.8MB

Ilya Evseev (ilya-evseev-gmail) wrote :

The same bug under Lubuntu 12.04 32bit.

Kernel 3.2.0-56-generic #86-Ubuntu SMP
upower 0.9.15-3git1ubuntu0.1

After 3 days of uptime, upowerd eats 45% of 2G RAM.

Mateusz Maćkowski (m4tx) wrote :

Ubuntu GNOME 14.04 LTS
Linux 3.13.0-30-generic #54-Ubuntu SMP Mon Jun 9 22:45:01 UTC 2014 x86_64 x86_64 x86_64 GNU/Linux
upower 0.99.0-2~trusty1

The bug affects me as well. At this moment it eats 1,1GB of RAM (my current uptime: almost 10 hours). I'm using Logitech Universal Receiver (I saw that this bug also affects other distros and is probably related to this device).

mako (marcus-yass-a) wrote :

I can corroborate the link to the logitech universal receiver, however for me upowerd eats so much memory that the whole system slows down.

Martin Pitt (pitti) wrote :

I don't have such a device, so I'm afraid I either need someone with such a device to debug this, or get ssh access to an affected machine. As a first step, please install valgrind, and run this:

  sudo killall upowerd; sudo valgrind --leak-check=full -- /usr/lib/upower/upowerd -v 2>&1 | tee /tmp/upower.log

There should be a lot of text at the initialization, and then I expect some regular updates for the wireless keyboard/mouse batteries. These will hopefully go along with some valgrind leak traces. It should be sufficient to just let that run for maybe 10 minutes, then press Control-C, and attach /tmp/upower.log here.

Thanks!

summary: - upowerd is using too much memory
+ upowerd leaks memory with Logitech universal receiver
Changed in upower (Ubuntu):
status: Confirmed → Incomplete
Peter Wu (lekensteyn) wrote :

UPower 0.99.1 had one minor fix which fixed a memleak:
dbb9bead6d3b9e70a5d58019b1615d2a6fba5312

Another leak fix:
b1aeed994884602b3601a7f4b98419c65be9009c

I am working to flesh out more memory leaks here:
https://git.lekensteyn.nl/upower/log/?h=memleak-fixes

The GetStatistics calls are probably the ones which result in the largest memory leaks.

Peter Wu (lekensteyn) wrote :

Correct bug link (what does UPower have to do with LO :/)
https://bugs.freedesktop.org/show_bug.cgi?id=82659

Martin Pitt (pitti) on 2014-11-18
Changed in upower (Ubuntu):
status: Incomplete → Confirmed
Peter Wu (lekensteyn) wrote :

FYI, this bug is fixed upstream.

Debian has applied a single patch[0] that takes care of the greatest offender, upstream has more fixes[1] that plugs the remaining leaks.

 [0]: https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=766762
 [1]: https://bugs.freedesktop.org/show_bug.cgi?id=82659

Martin Pitt (pitti) on 2014-12-02
Changed in upower (Ubuntu):
status: Confirmed → Triaged
assignee: nobody → Martin Pitt (pitti)
Changed in upower (Ubuntu Vivid):
milestone: none → ubuntu-15.01
Martin Pitt (pitti) on 2014-12-18
Changed in upower (Ubuntu Vivid):
status: Triaged → Fix Committed
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package upower - 0.99.2-1

---------------
upower (0.99.2-1) experimental; urgency=medium

  * New upstream bug fix release:
    - Fix memory leaks with Logitech receivers. (LP: #757551)
    - Drop all debian/patches/*, included upstream.
  * Bump Standards-Version to 3.9.6 (no changes necessary).

 -- Martin Pitt <email address hidden> Thu, 18 Dec 2014 14:29:46 +0100

Changed in upower (Ubuntu Vivid):
status: Fix Committed → Fix Released
Krzysztof Dryja (cih997) wrote :

Guys, how to implement the fix on Ubuntu 14.04.1 LTS without upgrading Ubuntu to the latest version?

Lee Hyde (anubeon) wrote :

Is there any chance of release for the allegedly LTS Ubuntu 'Trusty' 14.04? This bug is causing me major headaches.

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers

Remote bug watches

Bug watches keep track of this bug in other bug trackers.